from Globals import DTMLFile

from Products.HtmlArea3.HtmlArea import HtmlAreaMixin
from OFS.Folder import Folder
from AccessControl import getSecurityManager

manage_addFolderForm=DTMLFile('dtml/folderAdd', globals())

def manage_addFolder(self, id, title='',
                     createPublic=0,
                     createUserF=0,
                     REQUEST=None):
    """Add a new Folder object with id *id*.

    If the 'createPublic' and 'createUserF' parameters are set to any true
    value, an 'index_html' and a 'UserFolder' objects are created respectively
    in the new folder.

    Shamelessly pinched from OFS.Folder (Zope 2.6.1)
    """
    ob=FolderPlusPlus() # the only change
    ob.id=str(id)
    ob.title=title
    self._setObject(id, ob)
    ob=self._getOb(id)

    checkPermission=getSecurityManager().checkPermission

    if createUserF:
        if not checkPermission('Add User Folders', ob):
            raise Unauthorized, (
                  'You are not authorized to add User Folders.'
                  )
        ob.manage_addUserFolder()

    if createPublic:
        if not checkPermission('Add Page Templates', ob):
            raise Unauthorized, (
                  'You are not authorized to add Page Templates.'
                  )
        ob.manage_addProduct['PageTemplates'].manage_addPageTemplate(
            id='index_html', title='')

    if REQUEST is not None:
        return self.manage_main(self, REQUEST, update_menu=1)

class FolderPlusPlus(Folder, HtmlAreaMixin):
    """
    a folder which lets all contained Objects acquire
    the htmlArea for Zope methods
    """
    meta_type = 'Folder +htmlArea3'
    
constructors = (manage_addFolderForm, manage_addFolder)
